<template>
  <ob-form
    class="contract-direction-form"
    :form-data="formData"
    :form-model="formModel"
    :is-read-only="!isDraft"
    data-qa="directionForm"
    @submit="onSubmitHandler"
    :ok-text="isNew ? 'Добавить' : 'Сохранить'"
    cancel-text="Отменить"
  >
    <p class="mb30">
      <template v-if="service.resourceSpeciesTitle">
        {{ service.serviceTypeTitle }}.<br>
        {{ service.resourceSpeciesTitle }}. {{service.resourceSubtypeTitle}}.
        {{ service.resourcePatternParameter }}. {{ service.serviceUnitTitle }}.
      </template>
      <template v-else>
        {{ service.serviceTypeTitle }}. {{ service.serviceUnitTitle }}.
      </template>
    </p>
    <template v-if="isNew">
      <ObSelect
        v-if="isNew"
        v-model="formData.locationFromUuid"
        label="Откуда"
        placeholder="Укажите начальную точку маршрута"
        :remote-opt="api.contract.getLocations"
        :is-search="true"
        display-exp="russian_name"
        class="mb20"
        data-qa="locationFrom"
      />
      <ObSelect
        v-if="isNew"
        v-model="formData.locationToUuid"
        label="Куда"
        placeholder="Укажите конечную точку маршрута"
        :remote-opt="api.contract.getLocations"
        :is-search="true"
        display-exp="russian_name"
        class="mb30"
        data-qa="locationTo"
      />
    </template>
    <div class="nds-row mb30 mt20">
      <i class="icon alert" />
      <span v-if="isVatPayer">{{ service.isVatInclude ? 'Все тарифы включают в себя НДС' : 'Тарифы указываются без учета НДС' }} {{ service.vatValue || 20 }}%</span>
      <span v-else>Не облагается НДС</span>
    </div>
    <div class="row mb15">
      <div class="col-xs-6">
        <div class="sub-title">Тариф перевозки в один конец:</div>
        <div class="row">
          <div class="col-xs-6">
            <ObInput
              v-model="formData.tariff"
              label="Тариф в один конец"
              sub-title="₽"
              placeholder="56 000"
              type="money:2"
              :readonly="!isDraft"
              data-qa="tariff"
            />
          </div>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col-xs-6">
        <div class="sub-title">Тариф допробега (необязательно):</div>
        <div class="row">
          <div class="col-xs-6">
            <ObInput
              v-model="formData.extraMileageTariff"
              label="Тариф допробега"
              sub-title="₽/км"
              placeholder="Укажите"
              type="money:2"
              :readonly="!isDraft"
              data-qa="extraMileageTariff"
            />
          </div>
        </div>
      </div>
      <div class="col-xs-6">
        <div class="sub-title">Тариф за допточку (необязательно):</div>
        <div class="row">
          <div class="col-xs-6">
            <ObInput
              v-model="formData.extraPointTariff"
              label="Тариф за допточку"
              sub-title="₽"
              placeholder="Укажите"
              type="money:2"
              :readonly="!isDraft"
              data-qa="extraPointTariff"
            />
          </div>
        </div>
      </div>
    </div>
  </ob-form>
</template>

<script>
  import { mapState, mapGetters } from 'vuex'
  import api from '@/api'
  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
  import models from '@/models'
  import cloneDeep from 'clone-deep'
  import ObForm from 'common-components/src/obComponents/obForm'
  import ObInput from 'common-components/src/obComponents/obInput'
  import ObSelect from 'common-components/src/obComponents/obSelect'

  export default {
    name: 'ContractDirectionForm',
    components: {
      ObSelect,
      ObInput,
      ObForm
    },
    mixins: [
      FormValidationMixin
    ],
    data () {
      return {
        api,
        dropdownMenu: [
          {
            label: 'Отключить направление',
            method: this.disableDirection
          }
        ]
      }
    },
    computed: {
      ...mapState({
        service: state => state.contract.editedService
      }),
      ...mapGetters({
        isDraft: 'contract/isDraft',
        isVatPayer: 'contract/isDoerVatPayer'
      }),
      formModel () {
        return models.contract.directions
      },
      isNew () {
        return !this.formData.directionUuid
      }
    },
    methods: {
      onSubmitHandler () {
        let data = cloneDeep(this.formData);
        this.$emit('submit', {formData: data, model: this.formModel})
      },
      disableDirection () {
        this.$emit('on-disable-direction', { uuid: this.formData.directionUuid })
      }
    }
  }
</script>

<style lang='scss' scoped>
  @import '~common-components/src/static/css/mixins';

  .contract-direction-form {
    .main-title {
      @include font-mixin(20px, 28px, 600, $color-text-base, 0.4px);
    }

    .sub-title {
      margin-bottom: 10px;
      @include font-mixin(16px, 24px, 600, $color-text-base, 0.4px);
    }

    .nds-row {
      width: 100%;
      display: flex;
      align-items: center;
      padding: 20px;
      background-color: $color-white-lilac;
      .icon {
        font-size: 24px;
        color: $color-blue-navy-blue;
      }
      span {
        padding-left: 20px;
        font-size: 14px;
        line-height: 20px;
        color: $color-text-base;
      }
    }
  }
</style>

<style lang="scss">
  .contract-direction-form {
    .mt20 {
      margin-top: 20px!important;
    }

    .mb20 {
      margin-bottom: 20px !important;
    }

    .mb15 {
      margin-bottom: 15px !important;
    }

    .mb30 {
      margin-bottom: 30px!important;
    }

    .checkbox-input {
      display: flex;
      justify-content: flex-start;
      align-items: center;

      .ob-checkbox-container {
        flex-shrink: 0;
        margin-left: 20px;
      }
    }
  }
</style>
